tbb::interface7::internal::padded_mutex< Mutex, false > Class Template Reference

`#include <_mutex_padding.h>`

Inheritance diagram for tbb::interface7::internal::padded_mutex< Mutex, false >:
Collaboration diagram for tbb::interface7::internal::padded_mutex< Mutex, false >:

## Classes

class | scoped_lock
| Represents acquisition of a mutex. More...

## Public Member Functions

| padded_mutex ()
| ~padded_mutex ()

## Static Public Attributes

static const bool | is_rw_mutex = Mutex::is_rw_mutex
static const bool | is_recursive_mutex = Mutex::is_recursive_mutex
static const bool | is_fair_mutex = Mutex::is_fair_mutex

## Private Types

typedef long | pad_type

## Private Member Functions

Mutex * | impl ()

## Private Attributes

pad_type | my_pad [((sizeof(Mutex)+cache_line_size-1)/cache_line_size+1) *cache_line_size/sizeof(pad_type)]

## Detailed Description

### template<typename Mutex>
class tbb::interface7::internal::padded_mutex< Mutex, false >

Definition at line 35 of file _mutex_padding.h.

## Member Typedef Documentation

## pad_type

template<typename Mutex >

typedef long tbb::interface7::internal::padded_mutex< Mutex, false >::pad_type

private

Definition at line 36 of file _mutex_padding.h.

## Constructor & Destructor Documentation

## padded_mutex()

template<typename Mutex >

tbb::interface7::internal::padded_mutex< Mutex, false >::padded_mutex | ( |  | ) |

inline

Definition at line 46 of file _mutex_padding.h.

{ new(impl()) Mutex(); }
tbb::interface7::internal::padded_mutex< Mutex, false >::impl
Mutex * impl()
Definition: _mutex_padding.h:39

## ~padded_mutex()

template<typename Mutex >

tbb::interface7::internal::padded_mutex< Mutex, false >::~padded_mutex | ( |  | ) |

inline

Definition at line 47 of file _mutex_padding.h.

{ impl()->~Mutex(); }

## Member Function Documentation

## impl()

template<typename Mutex >

Mutex* tbb::interface7::internal::padded_mutex< Mutex, false >::impl | ( |  | ) |

inline private

Definition at line 39 of file _mutex_padding.h.

{ return (Mutex *)((uintptr_t(this)|(cache_line_size-1))+1);}
tbb::interface7::internal::cache_line_size
static const size_t cache_line_size
Definition: _mutex_padding.h:28

References tbb::interface7::internal::cache_line_size.

## Member Data Documentation

## is_fair_mutex

template<typename Mutex >

const bool tbb::interface7::internal::padded_mutex< Mutex, false >::is_fair_mutex = Mutex::is_fair_mutex

static

Definition at line 44 of file _mutex_padding.h.

## is_recursive_mutex

template<typename Mutex >

const bool tbb::interface7::internal::padded_mutex< Mutex, false >::is_recursive_mutex = Mutex::is_recursive_mutex

static

Definition at line 43 of file _mutex_padding.h.

## is_rw_mutex

template<typename Mutex >

const bool tbb::interface7::internal::padded_mutex< Mutex, false >::is_rw_mutex = Mutex::is_rw_mutex

static

Definition at line 42 of file _mutex_padding.h.

## my_pad

template<typename Mutex >

pad_type tbb::interface7::internal::padded_mutex< Mutex, false >::my_pad[((sizeof(Mutex)+cache_line_size-1)/cache_line_size+1) *cache_line_size/sizeof(pad_type)]

private

Definition at line 37 of file _mutex_padding.h.

The documentation for this class was generated from the following file:

- _mutex_padding.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.